/* MainMenu.c */
/* Created 3/13/4 1:08 PM by AppMaker */


#include "Globals.h"
#include "ResourceDefs.h"
#include "FileM.h"
#include "EditM.h"

#include "MainMenu.h"

#define NIL			0L

/*----------*/
void InitTitles ()
{
	InitFileM ();
	InitEditM ();
	} /*InitTitles*/
 
/*----------*/
void LoadMenus ()
{
	AppleMenu	= GetMenu (AppleID);
	AddResMenu (AppleMenu, 'DRVR');
	FileMenu	= GetMenu (FileID);
	EditMenu	= GetMenu (EditID);
	
	InsertMenu (AppleMenu, 0);
	InsertMenu (FileMenu, 0);
	InsertMenu (EditMenu, 0);
	
	DrawMenuBar ();
} /*LoadMenus*/

/*----------*/
static void DoAbout (void);
static void DoAbout ()
{
	short			itemNr;
	
	itemNr = Alert (AboutID, nil);
} /*DoAbout*/
 
/*----------*/
void DoApple (short		itemNr);
void DoApple (itemNr)
short			itemNr;
{
	Str255			name;
	short			refNum;

	switch (itemNr) {
	case AppleAbout:
			DoAbout ();
		break;
		default:
			GetItem (AppleMenu, itemNr, name);
			refNum = OpenDeskAcc (name);
		break;
	} /*switch*/
} /*DoApple*/

/*----------*/
void DoMenu (menuChoice)
long			menuChoice;
{
	short			menuID;
	short			itemNr;

	menuID = HiWord (menuChoice);
	itemNr = LoWord (menuChoice);
	
	switch (menuID) {
	case 0:
			/*Do nothing*/;
		break;
	case AppleID:
			DoApple (itemNr);
		break;
	case FileID:
			DoFile (itemNr);
		break;
	case EditID:
			DoEdit (itemNr);
		break;
		} /*switch*/

    HiliteMenu (0);
} /*DoMenu*/
 
/*----------*/
MenuHandle		menu;
Boolean			menuBarChanged;

/*----------*/
static void Enable (short			itemNr,
		 Boolean		enabled);
static void Enable (itemNr, enabled)
short		itemNr;
Boolean		enabled;
{
	if (enabled) {
		EnableItem  (menu, itemNr);
	} else {
		DisableItem (menu, itemNr);
	}
} /*Enable*/

/*----------*/
static void EnableTitle (MenuHandle	menu,
			  Boolean		enabled);
static void EnableTitle (menu, enabled)
MenuHandle		menu;
Boolean			enabled;
{
	if (enabled != ((**menu).enableFlags & 1)) {
		menuBarChanged = true;
	}
	if (enabled) {
		EnableItem  (menu, 0);
	} else {
		DisableItem (menu, 0);
	}
} /*EnableTitle*/

/*----------*/
void UpdateMenus ()
{
	WindowPeek		frontPeek;
	Boolean			isFront;	/*is there a front window?*/
	Boolean			isCur;		/*is there a current window?*/
	Boolean			isDirty;	/*is it dirty?*/
	Boolean			hasFile;	/*does it have a file?*/
	Boolean			isSelected;	/*is anything selected?*/
	Boolean			isDesk;		/*is the front window a desk acc?*/
	Boolean			isText;		/*is there a current text field?*/
	Boolean			isScrap;	/*is there any scrap?*/

	menuBarChanged = false;

	isFront		= (FrontWindow () != nil);
	isCur		= (curWindow != nil);
	isDirty 	= false;
	hasFile 	= false;
	isSelected	= false;
	if (isCur) {
		isDirty		=  cur->dirty;
		hasFile		= (cur->fileNum != 0);
	}

	isDesk = false;
	if (isFront) {
		frontPeek	= (WindowPeek) FrontWindow ();
		isDesk		= (frontPeek->windowKind < 0);
	}
	isText		= isCur && (cur->text != nil);
	isScrap		= false;
	if (isText) {
		isSelected	= ((**(cur->text)).selStart != (**(cur->text)).selEnd);
		isScrap		= (TEGetScrapLen () > 0);
	}

	menu = FileMenu;
	Enable (FileClose,		isFront);
	Enable (FileSave,		isDirty);
	Enable (FileSaveAs,		hasFile);
	Enable (FileRevert,		isDirty && hasFile);
	
	menu = EditMenu;
	if (isFront) {
		Enable (EditUndo,		isDesk);
		Enable (EditCut,		isDesk || isSelected);
		Enable (EditCopy,		isDesk || isSelected);
		Enable (EditPaste,		isDesk || isScrap);
		Enable (EditClear,		isDesk || isSelected);
		Enable (EditSelectAll,	isText);
		}
	EnableTitle (EditMenu,	 isFront);
	
		
	if (menuBarChanged) {
		DrawMenuBar ();
	}
} /*UpdateMenus*/

/* MainMenu */